<tw_ethereum_stripe>
    <div class="content-block inset">
		<div class="content-block-inner">
			<div class="row no-gutter" style="text-align: center">
				<input id="amount" value="{tmpAmount}" />
			</div>
			<div class="row no-gutter" style="text-align: center">
				<div class="col-25" onclick="{keypress}"><button>1</button></div>
				<div class="col-25" onclick="{keypress}"><button>2</button></div>
				<div class="col-25" onclick="{keypress}"><button>3</button></div>
				<div class="col-25" onclick="{keypress}"><button style="font-size: 1em; padding-top: 1.7em; padding-bottom: 1.8em;">BACK</button></div>
			</div>
			<div class="row no-gutter" style="text-align: center">
				<div class="col-25" onclick="{keypress}"><button>4</button></div>
				<div class="col-25" onclick="{keypress}"><button>5</button></div>
				<div class="col-25" onclick="{keypress}"><button>6</button></div>
				<div class="col-25" if="{op!='-'}" onclick="{keypress}"><button>-</button></div>
				<div class="col-25" if="{op=='-'}" onclick="{keypress}"><button style="color: {MAJOR_COLOR}">-</button></div>
			</div>
			<div class="row no-gutter" style="text-align: center">
				<div class="col-25" onclick="{keypress}"><button>7</button></div>
				<div class="col-25" onclick="{keypress}"><button>8</button></div>
				<div class="col-25" onclick="{keypress}"><button>9</button></div>
				<div class="col-25" if="{op!='+'}" onclick="{keypress}"><button>+</button></div>
				<div class="col-25" if="{op=='+'}" onclick="{keypress}"><button style="color: {MAJOR_COLOR}">+</button></div>
			</div>
			<div class="row no-gutter" style="text-align: center">
				<div class="col-25" onclick="{keypress}"><button>C</button></div>
				<div class="col-25" onclick="{keypress}"><button>0</button></div>
				<div class="col-25" onclick="{keypress}"><button>00</button></div>
				<div class="col-25" onclick="{keypress}"><button>=</button></div>
			</div>
		</div>
	</div>
    <div class="list-block inset">
		<ul>
			<li class="item-content">
				<div class="item-media"><i class="fa fa-credit-card fa-fw" aria-hidden="true"></i></div>
				<div class="item-inner">
					<div class="item-input">
						<form action="/charge" method="post" id="payment-form">
                            <div class="form-row">
                                <div id="card-element">
                                    <!-- a Stripe Element will be inserted here. -->
                                </div>

                             
                            </div>
                        </form>
					</div>
				</div>
			</li>
			<li>
				<a class="button button-big" style="width: 100%; background: {MAJOR_COLOR}; border-color: {MAJOR_COLOR}; color: {MAJOR_CTR_COLOR}" onclick="{checkout}">CHECKOUT 線上刷卡</a>
			</li>
		</ul>
	</div>
    <div class="content-block inset">
         <!-- Used to display form errors -->
        <div id="card-errors" role="alert"></div>
    </div>
    <style>
        #amount{
			width: 100%;
			font-size: 1.5em;
			padding: 1em;
			text-align: right;
		}
		button{
			width: 100%;
			font-size: 1.5em;
			border: none;
			padding: 1em;
			background: #fefefe;
			color: #333;
			outline: none;
			cursor: pointer;
		}
		button:hover{
			transition: all 1s ease;
		}
    </style>
    <script>
        var tag = this;
        tag.cmpName = "tw_ethereum_stripe";
        tag.amount = 0;
		tag.tmpAmount = 0;
		tag.padString = "";
		tag.op = "";
        tag.stripe = Stripe('pk_live_8x88Bq3MeZPoybzdXtNMDMpl');
        tag.on("mount", function(){
            tagRegister[tag.cmpName] = this;
            tag.mountStripe();
        });
        tag.mountStripe = function(){
            // Create a Stripe client
            

            // Create an instance of Elements
            var elements = tag.stripe.elements();

            // Custom styling can be passed to options when creating an Element.
            // (Note that this demo uses a wider set of styles than the guide below.)
            var style = {
                base: {
                    color: '#32325d',
                    lineHeight: '18px',
                    fontFamily: '"Helvetica Neue", Helvetica, sans-serif',
                    fontSmoothing: 'antialiased',
                    fontSize: '16px',
                    '::placeholder': {
                        color: '#aab7c4'
                    }
                },
                invalid: {
                    color: '#fa755a',
                    iconColor: '#fa755a'
                }
            };

            // Create an instance of the card Element
            tag.card = elements.create('card', {style: style});

            // Add an instance of the card Element into the `card-element` <div>
            tag.card.mount('#card-element');

            // Handle real-time validation errors from the card Element.
            tag.card.addEventListener('change', function(event) {
                var displayError = document.getElementById('card-errors');
                if (event.error) {
                    displayError.textContent = event.error.message;
                } else {
                    displayError.textContent = '';
                }
            });

        }
        tag.keypress = function(e){
			var keyValue = e.target.innerText;
			switch(keyValue){
				case "+":
				case "-":
					tag.amount = tag.tmpAmount;
//					tag.tmpAmount = "";
					tag.padString = "";
					tag.op = keyValue;
					break;
				case "=":
					if ( tag.op == "+" )
						tag.amount += tag.padString*1;
					if ( tag.op == "-" )
						tag.amount -= tag.padString*1;
					tag.tmpAmount = tag.amount;
					tag.padString = "";
					tag.op="";
					break;
				case "C":
					tag.amount = 0;
					tag.tmpAmount = 0;
					tag.padString = "";
					break;
				case "BACK":
					tag.padString = tag.padString.slice(0, tag.padString.length-1);
					tag.tmpAmount = tag.padString * 1;
					break;
				default:
					tag.padString += keyValue;
					tag.tmpAmount = tag.padString * 1;
					break;
			}
			
			tag.update();
		}
        tag.checkout = function(){
            App.showIndicator();
            tag.stripe.createToken(tag.card).then(function(result) {
                if (result.error) {
                    // Inform the user if there was an error
                    var errorElement = document.getElementById('card-errors');
                    errorElement.textContent = result.error.message;
                } else {
                    // Send the token to your server
                    console.log(result.token);

                    var data = {};
                    
                    data['stripeToken'] = result.token;
                    data['amt'] = tag.tmpAmount;
                    data['description'] = "SUP - " + topWebStorage.getItem("UserId");
                    
                    console.log(data);
                    
                    $.ajax({
                        "url": API_ENDPOINT+"/payments/stripe/ethereum/"+topWebStorage.getItem("UserId"),
                        "method": "POST",
                        "data": data,
                        "success": function(data){
                            App.hideIndicator();
                            if ( data == null ){
                                App.alert('Pay Failure. <br/>付款失敗', 'FAILURE', function(){
    //                                tagRegister.tw_cmp.loadCmp("tw_payment_stripe");
                                });
                                return;
                            }
                            if ( data.status == "succeeded" ){
                                tagRegister.tw_profile_balance.reload();
                                App.alert('Welcome To Be Our Members. <br/>付款成功', 'SUCCESS', function(){
                                    tagRegister.tw_cmp.loadCmp("tw_ethereum_wallet");
                                });
                            }else{
                                App.alert('Pay Failure. <br/>付款失敗', 'FAILURE', function(){
    //                                tagRegister.tw_cmp.loadCmp("tw_payment_stripe");
                                });
                            }
                        },
                        "statusCode": {
                            460: function(_data){
                                App.hideIndicator();
                                App.alert('User Already Exists. <br/>使用者已存在', 'Oops...發生錯誤');
                            },
                            461: function(_data){
                                App.hideIndicator();
                                App.alert('Can Not Found Referral Member. <br/>介紹人不存在', 'Oops...發生錯誤');
                            },
                            462: function(_data){
                                App.hideIndicator();
                                App.alert('Insufficient balance. <br/>帳戶餘額不足', 'Oops...發生錯誤');
                            },
                            463: function(_data){
                                App.hideIndicator();
                                App.alert('Can not use this credit card. <br/>信用卡交易失敗', 'Oops...發生錯誤');
                            },
                            464: function(_data){
                                App.hideIndicator();
                                App.alert('User Already Exists. <br/>使用者不存在', 'Oops...發生錯誤');
                            },
                        }
                    });
                }
            });
		}
    </script>
</tw_ethereum_stripe>